package com.palserv.ebnf;

import java.util.*;

class Context {
	void init() {
	}
}

public class EbnfObject {
	ArrayList children;
	ArrayList parents;
	boolean isRoot = false;
	String vname;
	int level;
	boolean isFinal = false;

	public String toString() {
		return "class: "+this.getClass().getName() +
			"; vname = "+vname+"; level = "+level;
	}

	void addChild(EbnfObject e) {
		if (children == null) {
			children = new ArrayList();
		}
		children.add(e);
	}

	void addParent(EbnfObject e) {
		if (parents == null) {
			parents = new ArrayList();
		}
		parents.add(e);
	}

	ArrayList getChildren() {
		return children;
	}

	ArrayList getParents() {
		return parents;
	}

	void interpret(Context c) {
	}

	boolean getRoot() { return isRoot; }

	void setRoot(boolean b) {
		isRoot = b;
	}

	String getVname() { return vname; }

	void setVname(String s) {
		vname = s;
	}

	boolean getFinal() { return isFinal; }

	void setFinal(boolean f) {
		isFinal = f;
	}
}

class EbnfExpression extends EbnfObject {
}

class EbnfLiteral extends EbnfObject {
}

class EbnfAlternation extends EbnfObject {
	EbnfAlternation(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfSequence extends EbnfObject {
	EbnfSequence(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfWfc extends EbnfObject {
}

class EbnfVc extends EbnfObject {
}

class EbnfAnotB extends EbnfObject {
	EbnfAnotB(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfZeroOrMore extends EbnfObject {
	EbnfZeroOrMore(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfOneOrMore extends EbnfObject {
	EbnfOneOrMore(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfAorNothing extends EbnfObject {
	EbnfAorNothing(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfHex extends EbnfLiteral {
	EbnfHex(String s, int l) {
		vname = s;
		level = l;
		setFinal(true);
	}
}

class EbnfRange extends EbnfObject {
	EbnfRange(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfGroup extends EbnfObject {
	EbnfGroup(String s, int l) {
		vname = s;
		level = l;
	}
}

class EbnfString extends EbnfLiteral {
	EbnfString(String s, int l) {
		vname = s;
		level = l;
		setFinal(true);
	}
}

class EbnfVar extends EbnfObject {
	private EbnfVariable v;
	EbnfVar(String s, int l) {
		vname = s;
		level = l;
	}

	EbnfVariable getVar() { return v; }

	void setVar(EbnfVariable varb) {
		v = varb;
	}
}

class EbnfVariable extends EbnfObject {
	private String vnam;
	private String value;
	private int ruleNum;

	String getVname() {
		return vnam;
	}

	String getValue() {
		return value;
	}

	int getRuleNum() {
		return ruleNum;
	}

	EbnfVariable(String n, String v) {
		vnam = n;
		value = v;
	}

	EbnfVariable(String n, String v, int r) {
		ruleNum = r;
		vnam = n;
		value = v;
	}
}
