package com.palserv.ebnf;

import java.io.*;
import java.util.*;

public class XmlEbnf {
	int cnt;
	ArrayList vars;
	Context context;
	EbnfObject root;
	EbnfObject currObj;
	PrintWriter out;
	PrintWriter deb1out;
	int ruleNumber;
	boolean withinLine;
	String saveVarb;
	String saveValue;
	int saveNum;

	void init() {
		cnt = 0;
		vars = new ArrayList();
		context = new Context();
		root = new EbnfObject();
		root.setRoot(true);
		ruleNumber = 0;
		withinLine = false;
		saveVarb = new String();
		saveValue = new String();
		saveNum = 0;
	}

	EbnfObject getFile(String fileName) {
		init();
		BufferedReader in = null;

		try {
			in = new BufferedReader(new FileReader(fileName));
		} catch(IOException e) {
			System.err.println("Unable to open " + fileName + ": " +
				e.getMessage());
		}

		try {
			boolean flag = true;
			while (flag) {
				String iLine = in.readLine();
				cnt ++;
				if (iLine == null) {
					flag = false;
				} else {
					processLine(iLine);
				}
			}
			in.close();
		} catch(IOException e) {
			System.err.println("Unable to read from " + fileName + ": " +
				e.getMessage());
		}
		context.init();
		Iterator vi = vars.iterator();
		while (vi.hasNext()) {
			EbnfVariable ev = (EbnfVariable)vi.next();
			build(ev);
		}
		spt("about to open");
		try {
			out = new PrintWriter(new BufferedWriter(
				new FileWriter("ebnftest.txt")));
		} catch(IOException e) {
			System.err.println("IOException: "+e.getMessage());
		}
		doOne(root,"root");
		out.close();
		deb1out.close();
		return root;
	}

	void build(EbnfVariable ev) {
		String val = ev.getVname();
		String vlue = ev.getValue();

		if (val.equals("document")) {
			currObj = new EbnfExpression();
			root.addChild(currObj);
		} else {
			currObj = ev;
		}
deb1("*** Rule: ["+ev.getRuleNum()+"] "+val+" ::= "+vlue);
		ArrayList pcs = parsePieces(vlue,"'\"[","'\"]",2);
		pcs = parseArray(pcs,"[","]",3,1);
		pcs = parseGroups(pcs,"(",")",4,2);
		pcs = parseArray(pcs,"#x"," -|",5,3);
		pcs = parseArray(pcs,"|","",6,4);
		pcs = parseArray(pcs,"-","",7,4);
		pcs = parseArray(pcs,"?","",9,5);
		pcs = parseArray(pcs,"+","",10,5);
		pcs = parseArray(pcs,"*","",11,5);
deb1("=== about to call parseArray for variables");
		pcs = parseArray(pcs," ","",12,6);
		pcs = parseArray(pcs," ","",7,4);

		Iterator ip = pcs.iterator();
		while (ip.hasNext()) {
			TempPiece tp = (TempPiece)ip.next();
			String s = tp.getStr();
			int n = tp.getNdx();
			int l = tp.getLev();
deb1("looking at: "+s+"; ndx = "+n+"; level = "+l);
			if (n == 1) {
				serr("build: unparsed string: ",s);
			}
			if (n == 2) {
				currObj.addChild(new EbnfString(s, l));
			}
			if (n == 3) {
				currObj.addChild(new EbnfRange(s, l));
			}
			if (n == 4) {
				currObj.addChild(new EbnfGroup(s, l));
			}
			if (n == 5) {
				currObj.addChild(new EbnfHex(s, l));
			}
			if (n == 6) {
				currObj.addChild(new EbnfAlternation(s, l));
			}
			if (n == 7) {
				currObj.addChild(new EbnfAnotB(s, l));
			}
			if (n == 8) {
				currObj.addChild(new EbnfSequence(s, l));
			}
			if (n == 9) {
				currObj.addChild(new EbnfAorNothing(s, l));
			}
			if (n == 10) {
				currObj.addChild(new EbnfOneOrMore(s, l));
			}
			if (n == 11) {
				currObj.addChild(new EbnfZeroOrMore(s, l));
			}
			if (n == 12) {
				currObj.addChild(findVar(s));
			}
		}
	}

	void deb1(String s) {
		if (deb1out == null) {
			try {
				deb1out = new PrintWriter(new BufferedWriter(
					new FileWriter("deb1out.txt")));
			} catch(IOException e) {
				System.err.println("IOException: "+e.getMessage());
			}
		}
		deb1out.println(s);
//		  spt(s);
	}

	void doOne(EbnfObject e, String pre) {
		prt(pre + ": " + e.toString());
		ArrayList children = e.getChildren();
		String n = "child of " + e.getVname();
		if (children == null) {
			return;
		}
		Iterator i = children.iterator();
		while (i.hasNext()) {
			EbnfObject c = (EbnfObject)i.next();
			doOne(c,n);
		}
	}

	void prt(String s) {
//		  try {
			out.println(s);
/*
		} catch(IOException e) {
			System.err.println("IOException: "+e.getMessage());
		}
*/
	}

	ArrayList parseArray(ArrayList al, String dstrt, String dend,
			int m, int n) {
		if (n == 2) {
			serr("we should not be in parseArray with n = 2","");
//			  return parseGroups(al ,dstrt,dend,m,n);
		}

		ArrayList pcs = new ArrayList();
		if (al == null) {
			serr("parseArray: al is null",dstrt);
		}

deb1("parseArray: before loop; dstrt = "+dstrt+", dend = "+dend+", m = "+m+", n = "+n+", al = "+alToString(al));
		Iterator ial = al.iterator();
		while (ial.hasNext()) {
			TempPiece tp = (TempPiece)ial.next();
deb1("parseArray: within loop, ndx = "+tp.getNdx()+" - "+tp.getStr());
			if (tp.getNdx() == 1) {
				ArrayList t = null;
				if (n == 1) {
					t = parsePieces(tp.getStr(),dstrt,dend,m);
				}
				if (n == 3) {
					t = parseSingle(tp.getStr(),dstrt,dend,m);
				}
				if (n == 4) {
					t = parseBinary(tp.getStr(),dstrt,dend,m);
				}
				if (n == 5) {
					t = parseUnary(tp.getStr(),dstrt,dend,m);
				}
				if (n == 6) {
					t = parseVariable(tp.getStr(),dstrt,dend,m);
				}
				if (t != null) {
					Iterator ti = t.iterator();
					while (ti.hasNext()) {
						TempPiece xtp = (TempPiece)ti.next();
//						  alAdd(pcs, (TempPiece)ti.next());
						alAdd(pcs,xtp);
deb1("parseArray: adding to pcs from t: "+xtp.getStr());
		if (pcs == null) {
			serr("parseArray: pcs is null just after add",dstrt);
		}
					}
				}
			} else {
				alAdd(pcs, tp);
deb1("parseArray: adding to pcs from tp: "+tp.getStr());
			}
		}
		if (pcs == null) {
			serr("parseArray: pcs is null",dstrt);
		}
		return pcs;
	}

	ArrayList copyArrayList(ArrayList c) {
		ArrayList n = new ArrayList();
		Iterator i = c.iterator();
		while (i.hasNext()) {
			n.add(i.next());
		}
		return n;
	}

	SE findFirst(ArrayList al, String fstr, SE cpos) {
		// find first occurrance of fstr in the strings of al
		// ignoring pieces with an index not equal to 1
		Iterator i = al.iterator();
		int c = -1;
		while (i.hasNext()) {
			TempPiece t = (TempPiece)i.next();
			c ++;
			if (c < cpos.index) {
				continue;
			}
			int cp = 0;
			if (c == cpos.index) {
				cp = cpos.lowest;
			}

			if (t.getNdx() == 1) {
				int p = t.getStr().indexOf(fstr, cp);
				if (p != -1) {
// SE(lowest,index)
					return new SE(p,c);
				}
			}
		}
		return new SE(-1,-1);
	}

	String alToString(ArrayList al) {
		// for debugging
		Iterator i = al.iterator();
		String r = "ArrayList: ";
		int ndx = 0;
		while (i.hasNext()) {
			TempPiece tp = (TempPiece)i.next();
			r += "\nndx = "+ndx+": "+tp.getStr()+", "+tp.getNdx()+", "+tp.getLev()+"; ";
			ndx ++;
		}
		return r;
	}

	String SEToString(SE se) {
		// for debugging
		return "SE("+se.lowest+","+se.index+")";
	}

	ArrayList parseGroups(ArrayList pcs, String dstrt, String dend,
			int m, int n) {
deb1("in parseGroups: pcs = "+alToString(pcs));
		ArrayList al = new ArrayList();
		ArrayList tmp = copyArrayList(pcs);

		int level = 0;
		SE currPos = new SE(0,0);
		ArrayList strtList = new ArrayList();
		boolean flag = true;
		while (flag) {
			SE ses = findFirst(tmp,dstrt,currPos);
			SE see = findFirst(tmp,dend,currPos);
deb1("parseGroups: after findFirst: currPos: "+SEToString(currPos)+", ses: "+SEToString(ses)+", see: "+SEToString(see));
			if (ses.index == -1 && see.index == -1) {
				// add what is in tmp to al, then return al
deb1("parseGroups: adding to al: tmp = "+alToString(tmp));
				if (! tmp.isEmpty()) {
					int tndx = tmp.size() - 1;
					TempPiece ttp = (TempPiece)tmp.get(tndx);
					String ts = ttp.getStr();
					addToAl(al,tmp,new SE(0,0),new SE(ts.length(), tndx), -1, -1);
				}
				return al;
			}
			if (see.index == -1) {
				serr("parseGroup: start with no end: ","");
			}
			if (ses.index == -1) {
				// finish the start-end pair
deb1("parseGroups: ses.index == -1");
				SCP scp = finStrEndPair(strtList, al, tmp, see, m, level);
				tmp = scp.getStr();
				currPos = new SE(scp.getLen());
				level --;
			} else { // we found both start and end
				if (ses.compare(see) == -1) {  // if start < end
					// "register" the start
deb1("parseGroup: adding ses "+SEToString(ses)+" to strtList");
					strtList.add(ses);
					level ++;
					currPos = new SE(ses);
					currPos.increment(tmp);
				} else {  // nd < strt
					// finish the start-end pair
deb1("parseGroup: nd < strt");
					SCP scp = finStrEndPair(strtList, al, tmp, see, m, level);
					tmp = scp.getStr();
					currPos = new SE(scp.getLen());
					level --;
				}
			}
		}
deb1("parseGroup: returning al = "+alToString(al));
		return al;
	}

	ArrayList parseSingle(String v, String dstrt, String dend, int m) {
deb1("parseSingle: "+v);
		ArrayList al = new ArrayList();
		String tmp = v;
		ArrayList strtList = new ArrayList();
		boolean flag = true;
		while (flag) {
			tmp = tmp.trim();
			if (tmp == null || tmp.equals("")) {
				return al;
			}
			int strt = tmp.indexOf(dstrt);
			if (strt == -1) {
				alAdd(al, new TempPiece(tmp,1));
				return al;
			}
			int nd = tmp.length() + 10;
			for (int i = 0; i < dend.length(); i ++) {
				String c = dend.substring(i, i + 1);
				int n = tmp.indexOf(c,strt + 1);
				if (n != -1 && n < nd) {
					nd = n;
				}
			}
			if (nd == tmp.length() + 10) {
				// on end found; use end of string
				nd = tmp.length();
			}
deb1("parseSingle: before alAdd: tmp = "+tmp+", strt = "+strt+", dstrt = "+dstrt+", dend = "+dend+", nd = "+nd);
			alAdd(al, new TempPiece(tmp.substring(strt+dstrt.length(),nd),m));
			if (nd == tmp.length()) {
				tmp = "";
			} else {
				tmp = tmp.substring(nd + 1);
			}
		}
		return al;
	}

	SCP finStrEndPair(ArrayList strtList, ArrayList al, ArrayList tmp,
			SE see, int m, int lev) {
		if (strtList.isEmpty()) {
			serr("finStrEndPair: strtList is empty!","al = "+alToString(al)+", tmp ="+alToString(tmp));
		}
		int ndx = strtList.size() - 1;
		SE ses = (SE)strtList.get(ndx);
deb1("finStrEndPair: pulling ses: "+SEToString(ses)+" off strtList");
		int str = ses.index;
deb1("finStrEndPair: adding tmp to al");
		SE tses = new SE(ses);
		tses.increment(tmp);
		SE tsee = new SE(see);
deb1("finStrEndPair: see before decrement: "+SEToString(tsee));
		tsee.decrement(tmp);
deb1("finStrEndPair: see after decrement: "+SEToString(tsee));
		addToAl(al, tmp, tses, tsee, m, lev);
		strtList.remove(ndx);

		// if anything before start of group, add to tmp
		ArrayList pre = new ArrayList();
		if (ses.index > 0 || ses.lowest > 0) {
deb1("finStrEndPair: adding tmp to pre, (0,0) to ses");
			addToAl(pre,tmp, new SE(0,0), ses, -1, -1);
		}

		ndx = tmp.size() - 1;
		TempPiece tp = (TempPiece)tmp.get(ndx);
		int len = tp.getStr().length();
		if (see.index < ndx || see.lowest < len) {
			SE nsee = new SE(see);
			nsee.increment(tmp);
deb1("finStrEndPair: adding tmp to pre, nsee: "+SEToString(nsee)+" to ("+len+","+ndx+")");
			addToAl(pre, tmp, nsee, new SE(len,ndx), -1, -1);
		}

		return new SCP(pre, ses);
	}

	void addToAl(ArrayList al, ArrayList tmp, SE ses, SE see, int m, int lev) {
		// add the parts of tmp from ses to see to al
deb1("addToAl: adding tmp to al: ses: "+SEToString(ses)+" see: "+SEToString(see)+", tmp: "+alToString(tmp)+"\nal: "+alToString(al));
		Iterator i = tmp.iterator();
		int c = -1;
		while (i.hasNext()) {
			c ++;
			TempPiece tp = (TempPiece)i.next();
			if (c < ses.index) {
				continue;
			}
			if (c > see.index) {
				return;
			}

			int cp = 0;
			if (c == ses.index) {
				cp = ses.lowest;
			}

			String s = tp.getStr();
			int ep = s.length();
			if (c == see.index) {
				if (see.lowest > ep) {
					serr("addToAl: see.lowest > ep; see: "+SEToString(see)+", s = "+s,"al: "+alToString(al));
				}
				ep = see.lowest;
			}

			int newm = m;
			if (newm == -1) {
				newm = tp.getNdx();
			}
			int newlev = lev;
			if (newlev == -1) {
				newlev = tp.getLev();
			}

			TempPiece ntp = new TempPiece(s.substring(cp,ep), m, lev);
//			  tp.setStr(s.substring(cp,ep));
			al.add(ntp);
		}
	}

	ArrayList parsePieces(String v, String dstrt, String dend, int m) {
deb1("parsePieces: "+v);
		ArrayList al = new ArrayList();
		String tmp = v;
		boolean flag = true;
		while (flag) {
			tmp = tmp.trim();
			if (tmp == null || tmp.equals("")) {
				return al;
			}
			SE ses = getFirst(tmp,dstrt);
			if (ses.index > dend.length()) {
				alAdd(al, new TempPiece(tmp, 1));
deb1("parsePieces: adding unparsed: "+tmp);
				return al;
			}
			String dst = dstrt.substring(ses.index,ses.index+1);
			String dnd = dend.substring(ses.index,ses.index+1);
			int strt = ses.lowest;
			int nd = tmp.indexOf(dnd,strt+1);
			if (strt > 0) {
				alAdd(al, new TempPiece(tmp.substring(0,strt),1));
deb1("parsePieces: adding unparsed: "+tmp.substring(0,strt));
			}
			if (nd == -1) {
				serr("parsePieces: no end " + dnd,v);
			}
			if (dst.equals("[")) {
				alAdd(al,new TempPiece(tmp.substring(strt+1,nd),3));
			} else {
				alAdd(al,new TempPiece(tmp.substring(strt+1,nd),m));
			}
// deb1("parsePieces: adding: "+tmp.substring(strt+1,nd));
			tmp = tmp.substring(nd+1);
		}
		return al;
	}

	SE getFirst(String str, String dlms) {
		int l = 10000;
		int i = 10000;
		for (int c = 0; c < dlms.length(); c ++) {
			int p = str.indexOf(dlms.substring(c,c+1));
			if (p != -1 && p < l) {
				l = p;
				i = c;
			}
		}
		return new SE(l,i);
	}

	ArrayList parseBinary(String v, String dstrt, String dend, int m) {
deb1("parseBinary: string = "+v+", strt = "+dstrt);
		ArrayList al = new ArrayList();
		String tmp = v;
		boolean flag = true;
		while (flag) {
			tmp = tmp.trim();
			if (tmp == null || tmp.equals("")) {
				return al;
			}
			int strt = tmp.indexOf(dstrt);
			if (strt == -1) {
				alAdd(al, new TempPiece(tmp,1));
				flag = false;
			} else {
				if (strt > 0) {
					alAdd(al, new TempPiece(tmp.substring(0,strt),1));
				}
				alAdd(al,new TempPiece(dstrt,m));
				tmp = tmp.substring(strt+1);
			}
		}
		return al;
	}

	ArrayList parseUnary(String v, String dstrt, String dend, int m) {
deb1("parseUnary: "+v);
		ArrayList al = new ArrayList();
		String tmp = v;
		boolean flag = true;
		while (flag) {
			tmp = tmp.trim();
			if (tmp == null || tmp.equals("")) {
				return al;
			}
			int strt = tmp.indexOf(dstrt);
			if (strt == -1) {
				alAdd(al, new TempPiece(tmp,1));
				flag = false;
			} else {
				if (strt > 0) {
					alAdd(al, new TempPiece(tmp.substring(0,strt),1));
				} else {
					serr("parseUnary: no string before: "+dstrt+" - ",v);
				}
				alAdd(al,new TempPiece(tmp.substring(0,strt),m));
				tmp = tmp.substring(strt+1);
			}
		}
		return al;
	}

	ArrayList parseVariable(String v, String dstrt, String dend, int m) {
deb1("parseVariable: "+v);
		ArrayList al = new ArrayList();
		String tmp = v;
		boolean flag = true;
		while (flag) {
			tmp = tmp.trim();
			if (tmp == null || tmp.equals("")) {
				return al;
			}
			int strt = tmp.indexOf(dstrt);
			if (strt == -1) {
				addVar(al, tmp, m);
				flag = false;
			} else {
				addVar(al, tmp.substring(0,strt),m);
				tmp = tmp.substring(strt+1);
			}
		}
		return al;
	}

	void addVar(ArrayList al, String tmp, int m) {
		if (onVars(tmp)) {
			alAdd(al, new TempPiece(tmp,m));
		} else {
deb1("variable not found: "+tmp);
			alAdd(al, new TempPiece(tmp,1));
		}
	}

	void alAdd(ArrayList a, TempPiece tp) {
/*
		if (a == null) {
			a = new ArrayList();
		}
*/
		a.add(tp);
	}

	EbnfVariable findVar(String k) {
		Iterator vi = vars.iterator();
		while (vi.hasNext()) {
			EbnfVariable ev = (EbnfVariable)vi.next();
			if (k.equals(ev.getVname())) {
				return ev;
			}
		}
		return null;
	}

	boolean onVars(String k) {
		Iterator vi = vars.iterator();
		while (vi.hasNext()) {
			EbnfVariable ev = (EbnfVariable)vi.next();
			if (k.equals(ev.getVname())) {
				return true;
			}
		}
deb1("### onVars: not found: "+k);
		return false;
	}

	void processLine(String lin) {
		String varb = null;
		String value = null;
		int rnum = 0;

		if (lin.substring(0,2).equals("/*")) {
			return;
		}
		if (withinLine) {
			withinLine = false;
			varb = saveVarb;
			value = saveValue + lin;
			rnum = saveNum;
		} else {
			int pLSB = lin.indexOf("[");
			int pRSB = lin.indexOf("]");
			int pCCE = lin.indexOf("::=");
			if (pLSB == -1) {
				serr("No left square bracket",lin);
			}
			if (pRSB == -1) {
				serr("No right square bracket",lin);
			}
			if (pCCE == -1) {
				serr("No colon colon equals",lin);
			}
			String ruleNum = lin.substring(pLSB + 1, pRSB).trim();
			Integer rn = new Integer(ruleNum);
			rnum = rn.intValue();
			if ((rnum - ruleNumber) > 1) {
				serr("missing rule number between "+ruleNumber+" and "+rnum,lin);
			}
			varb = lin.substring(pRSB + 1, pCCE - 1).trim();
			value = lin.substring(pCCE + 4);
		}
		int contNdx = lin.length() - 1;
		if (lin.substring(contNdx).equals("~")) {
			lin = lin.substring(0,contNdx);
			contNdx = value.length() - 1;
			value = value.substring(0,contNdx);
			saveVarb = varb;
			saveValue = value;
			saveNum = rnum;
			withinLine = true;
			return;
		}
		EbnfVariable ev = new EbnfVariable(varb, value, rnum);
		ruleNumber ++;
		vars.add(ev);
	}

	void serr(String s, String l) {
		deb1("Error in line " + cnt + ": " + s);
		spt("Error in line " + cnt + ": " + s);
		deb1("Line: " + l);
		spt("Line: " + l);
		deb1out.close();
		System.exit(0);
	}

	void spt(String s) {
		System.out.println(s);
	}

	public static void main(String[] args) {
		XmlEbnf t01 = new XmlEbnf();
		String fnam;
		if (args.length > 0) {
			fnam = args[0];
		} else {
			fnam = "XML-ebnf.txt";
		}
		t01.getFile(fnam);
	}
}

class TempPiece {
	private String str;
	private int ndx;
	private int lev;

	TempPiece(String s, int n) {
		str = s;
		ndx = n;
		lev = 0;
	}

	TempPiece(String s, int n, int l) {
		str = s;
		ndx = n;
		lev = l;
	}

	String getStr() { return str; }
	void setStr(String s) {
		str = s;
	}
	int getNdx() { return ndx; }
	int getLev() { return lev; }

	public String toString() {
		return "TempPiece: string="+str+", ndx="+ndx+", lev="+lev;
	}
}

class SCP {
	private ArrayList str;
	private SE len;

	SCP(ArrayList s, SE i) {
		str = s;
		len = i;
	}

	ArrayList getStr() { return str; }
	SE getLen() { return len; }
}

class SE {
	public int lowest;
	public int index;

	SE(int l, int i) {
		lowest = l;
		index = i;
	}

	SE(SE s) {
		this.lowest = s.lowest;
		this.index = s.index;
	}

	SE increment(ArrayList t) {
		if (index >= t.size()) {
			XmlEbnf xx = new XmlEbnf();
			xx.serr("SE.increment: index is too big, index = "+index,xx.alToString(t));
		}
		TempPiece tp = (TempPiece)t.get(index);
		String s = tp.getStr();
		int l = lowest + 1;
		if (l >= s.length()) {
			int i = index + 1;
			if (i >= t.size()) {
deb1("SE.increment already off end. lowest = "+lowest+", index = "+index);
				return this;
			}
			index = i;
			lowest = 0;
		} else {
			lowest = l;
		}
		return this;
	}

	SE decrement(ArrayList t) {
deb1("SE.decrement: before: "+this.toString());
		int l = lowest - 1;
		if (l < 0) {
			int i = index - 1;
			if (i < 0) {
deb1("SE.decrement already off end. lowest = "+lowest+", index = "+index);
				return this;
			}
			index = i;
			TempPiece tp = (TempPiece)t.get(index);
			String s = tp.getStr();
			lowest = s.length() - 1;
		} else {
			lowest = l;
		}
deb1("SE.decrement: after: "+this.toString());
		return this;
	}

	void deb1(String s) {
//		  System.out.println(s);
	}

	public String toString() {
		return "SE: ("+lowest+","+index+")";
	}

	int compare(SE c) {
/* compare "this" with argument "c"
	if this < c return -1
	if this = c return 0
	if this > c return 1
*/
		if (this.index < c.index) {
			return -1;
		}
		if (this.index > c.index) {
			return 1;
		}
		// index's are equal
		if (this.lowest < c.lowest) {
			return -1;
		}
		if (this.lowest > c.lowest) {
			return 1;
		}
		// lowest's are equal
		return 0;
	}
}
